%define full_name jakarta-%{name}
%define full_jname jasper4
%define jname jasper
%define majversion 4.1
%define servletspec 2.3
%define jspspec 1.2
%define section devel

%define tcuid 91

%define packname jakarta-tomcat-%{version}-src
%define conpackname jakarta-tomcat-connectors-%{version}-src
%define servpackname jakarta-servletapi-4-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir %{_sysconfdir}/%{name}
%define logdir %{_localstatedir}/log/%{name}
%define homedir %{_datadir}/%{name}
%define bindir %{homedir}/bin
%define tempdir %{_localstatedir}/cache/%{name}/temp
%define workdir %{_localstatedir}/cache/%{name}/work
%define appdir %{_localstatedir}/lib/%{name}/webapps
%define serverdir %{_localstatedir}/lib/%{name}/server
%define commondir %{_localstatedir}/lib/%{name}/common
%define shareddir %{_localstatedir}/lib/%{name}/shared

Summary: Apache Servlet/JSP Engine, RI for Servlet 2.3/JSP 1.2 API
Name: tomcat4
Version: 4.1.31
Release: 1jpp
Epoch: 0
License: Apache Software License
Vendor: JPackage Project
Distribution: JPackage
Group: Networking/Daemons
URL: http://jakarta.apache.org/tomcat/
BuildArch: noarch
Source0: jakarta-tomcat-%{version}-src.tar.gz
Source1: jakarta-tomcat-connectors-%{version}-src.tar.gz
Source2: jakarta-servletapi-4-src.tar.gz
Source3: %{name}-%{majversion}.init
Source4: %{name}-%{majversion}.conf
Source5: %{name}-%{majversion}.wrapper
Source6: %{full_jname}-%{majversion}.wrapper
Source7: %{name}-%{majversion}.logrotate
Source8: %{name}-%{majversion}.relink
Patch0: %{name}-%{version}-jasper.sh.patch
Patch1: %{name}-%{version}-jspc.sh.patch
Patch2: %{name}-%{version}-catalina.sh.patch
Patch3: %{name}-%{majversion}.link_admin_jar.patch
Patch4: %{name}-%{version}-allowTrace.patch
BuildRoot: %{_tmppath}/%{name}-%{epoch}-%{version}-%{release}-root

Requires: jpackage-utils >= 0:1.6.0
Requires: ant >= 0:1.6.1
Requires: java-devel >= 0:1.4.1
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Requires: %{name}-%{jname} = %{epoch}:%{version}-%{release}
# xml parsing packages
Requires: jaxp_parser_impl
Requires: xml-commons-apis
Requires: regexp >= 0:1.2
Requires: tyrex >= 0:1.0
# jakarta-commons packages
Requires: jakarta-commons-beanutils >= 0:1.4.1
Requires: jakarta-commons-collections >= 0:2.0
Requires: jakarta-commons-daemon
Requires: jakarta-commons-dbcp >= 0:1.1
Requires: jakarta-commons-digester >= 0:1.3
Requires: jakarta-commons-modeler
Requires: jakarta-commons-pool >= 0:1.0.1
Requires: jakarta-commons-logging >= 0:1.0.1
Requires: jakarta-commons-fileupload >= 0:1.0-1jpp
# alternatives
Requires: jmxri
Requires: jaas
Requires: jndi
Requires: jndi-ldap
Requires: jdbc-stdext
# non-free stuff
Requires: jta >= 0:1.0.1-0.a.1
# jaf can be provided by classpathx-jaf
Requires: jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
Requires: javamail >= 0:1.3

Buildrequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6.1
BuildRequires: ant-trax
BuildRequires: java-devel >= 0:1.4.1
BuildRequires: jaxp_transform_impl
BuildRequires: xalan-j2
BuildRequires: jakarta-commons-beanutils
BuildRequires: jakarta-commons-collections >= 0:2.0
BuildRequires: jakarta-commons-daemon
BuildRequires: jakarta-commons-dbcp >= 0:1.1
BuildRequires: jakarta-commons-digester >= 0:1.3
BuildRequires: jakarta-commons-logging >= 0:1.0.1
BuildRequires: jakarta-commons-fileupload >= 0:1.0
BuildRequires: jakarta-commons-modeler
BuildRequires: jakarta-commons-pool >= 0:1.0.1
BuildRequires: jaas
BuildRequires: jdbc-stdext >= 0:2.0
BuildRequires: jndi >= 0:1.2.1
BuildRequires: jndi-ldap
BuildRequires: jsse >= 0:1.0.2
BuildRequires: jta >= 0:1.0.1-0.a.1
BuildRequires: junit >= 0:3.7
BuildRequires: jmxri
BuildRequires: regexp >= 0:1.2
BuildRequires: puretls
BuildRequires: struts11 >= 0:1.1
BuildRequires: tyrex >= 0:1.0
BuildRequires: jaxp_parser_impl
BuildRequires: xml-commons-apis
# non-free stuff
BuildRequires: jta
# jaf can be provided by classpathx-jaf
BuildRequires: jaf >= 0:1.0.1
# javamail can be provided by classpathx-mail
BuildRequires: javamail >= 0:1.3

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License. Tomcat is intended to be
a collaboration of the best-of-breed developers from around the world.
We invite you to participate in this open development project. To
learn more about getting involved, click here.

%package webapps
Group: System Environment/Applications
Requires: %{name} = %{epoch}:%{version}-%{release}
Summary: Web applications for Jakarta Tomcat

%description webapps
Web applications for Jakarta Tomcat

%package admin-webapps
Group: System Environment/Applications
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: struts11 >= 0:1.1
Summary: The administrative web applications for Jakarta Tomcat

%description admin-webapps
The administrative web applications (admin and manager) for Jakarta Tomcat

%package servlet-%{servletspec}-api
Group: Internet/WWW/Dynamic Content
Requires: /usr/sbin/update-alternatives
Summary: Jakarta Tomcat Servlet and JSP implementation classes
Obsoletes: servletapi4
Provides: servlet
Provides: servlet4
Provides: servlet23
Provides: servletapi4

%description servlet-%{servletspec}-api
Contains the source code for the implementation classes
of the Jakarta Tomcat Servlet and JSP APIs (packages javax.servlet).

%package servlet-%{servletspec}-api-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-servlet-%{servletspec}-api
Obsoletes: servletapi4-javadoc

%description servlet-%{servletspec}-api-javadoc
Contains the javadoc generated documentation for the implementation classes
of the Jakarta Tomcat Servlet and JSP APIs (packages javax.servlet).

%package %{jname}
Group: Development/Compilers
Requires: %{name}-servlet-%{servletspec}-api = %{epoch}:%{version}-%{release}
Summary: Compiler JARs and associated scripts for %{name}

%description %{jname}
Compiler JARs and associated scripts for %{name}

%package %{jname}-javadoc
Group: Development/Documentation
Summary: Javadoc generated documentation for %{name}-%{jname}

%description %{jname}-javadoc
Javadoc for generated documentation %{name}-%{jname}

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0
%setup -q -c -T -D -a 1
%setup -q -c -T -D -a 2

cd $RPM_BUILD_DIR/%{name}-%{version}/%{packname}
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p1
%patch4 -p1

%build
# Remove pre-built jars and classes
cd $RPM_BUILD_DIR/%{name}-%{version}
for dir in %{packname} %{conpackname} %{servpackname}; do
    find $dir \( -iname "*.jar" -o -iname "*.class" \) | xargs -t rm -f
done

# build servlet.jar as ant dist will require it later
pushd $RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}
    ant dist -Dservletapi.build=build -Dservletapi.dist=dist
popd

# build jasper subpackage
export CLASSPATH=$(build-classpath xml-commons-apis xalan-j2)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/lib/servlet.jar

cd $RPM_BUILD_DIR/%{name}-%{version}/%{packname}
pushd %{jname}
    cat >> build.properties <<EOF
ant.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/%{conpackname}
jasper.home=./jasper
servlet.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/lib/servlet.jar
servlet.doc=$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/dist/docs/api
EOF
    # can't use jikes to build tomcat4 (strange)
    ant -Djava.home=%{java_home} -Dbuild.compiler=modern javadoc
popd

# build tomcat 4
export OPT_JAR_LIST="ant/ant-trax"
export CLASSPATH=$(build-classpath xml-commons-apis xalan-j2)
export CLASSPATH=$CLASSPATH:$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/lib/servlet.jar

cd $RPM_BUILD_DIR/%{name}-%{version}/%{packname}
cat >> build.properties <<EOF
ant.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/%{conpackname}
jasper.home=./jasper
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath jmxri)
jmxri.jar=$(build-classpath jmxri)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp)
servlet.jar=$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/lib/servlet.jar
servlet.doc=$RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/dist/docs/api
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xmlParserAPIs.jar=$(build-classpath xml-commons-apis)
struts.jar=$(build-classpath struts-1.1)
struts.lib=%{_datadir}/struts-1.1
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
tyrex.jar=$(build-classpath tyrex)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
compile.admin=true
EOF
# can't use jikes to build tomcat4 (strange)
export OPT_JAR_LIST="ant/ant-trax jaxp_transform_impl"
ant -Djava.home=%{java_home} -Dbuild.compiler=modern

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT/{%{_javadir},%{_javadocdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_sysconfdir}}
install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/{init.d,logrotate.d}
install -d -m 755 $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{jname}-%{version}
install -d -m 755 \
    $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-servlet-2.3-api-%{version}

# install servletapi subpackage
install -m 644 \
    $RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/dist/lib/servlet.jar \
    $RPM_BUILD_ROOT/%{_javadir}/servletapi4-%{version}.jar
pushd $RPM_BUILD_ROOT/%{_javadir}
    ln -s servletapi4-%{version}.jar servletapi4.jar
popd
cp -pr $RPM_BUILD_DIR/%{name}-%{version}/%{servpackname}/build/docs/api/* \
    $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-servlet-2.3-api-%{version}

# install jasper subpackage
install -m 755 \
    $RPM_BUILD_DIR/%{name}-%{version}/%{packname}/%{jname}/build/bin/jspc.sh \
    $RPM_BUILD_ROOT/%{_bindir}/jspc4
install -m 755 $RPM_BUILD_DIR/%{name}-%{version}/%{packname}/%{jname}/build/bin/%{jname}.sh \
    $RPM_BUILD_ROOT%{_bindir}/%{full_jname}
install -m 644 $RPM_BUILD_DIR/%{name}-%{version}/%{packname}/%{jname}/build/shared/lib/%{jname}-compiler.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{full_jname}-compiler-%{version}.jar
install -m 644 $RPM_BUILD_DIR/%{name}-%{version}/%{packname}/%{jname}/build/shared/lib/%{jname}-runtime.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{full_jname}-runtime-%{version}.jar
pushd $RPM_BUILD_ROOT/%{_javadir}
    ln -s %{full_jname}-compiler-%{version}.jar %{full_jname}-compiler.jar
    ln -s %{full_jname}-runtime-%{version}.jar %{full_jname}-runtime.jar
popd
cp -pr $RPM_BUILD_DIR/%{name}-%{version}/%{packname}/%{jname}/build/javadoc/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{jname}-%{version}

#install tomcat4
export CLASSPATH=$(build-classpath xalan-j2 xml-commons-apis ant/ant-trax)

cd $RPM_BUILD_DIR/%{name}-%{version}/%{packname}
export usejikes=false
ant -Djava.home=$JAVA_HOME dist
pushd dist
    mv bin/* ${RPM_BUILD_ROOT}/%{bindir}
    mv common/* ${RPM_BUILD_ROOT}/%{commondir}
    mv conf/* ${RPM_BUILD_ROOT}/%{confdir}
    mv server/* ${RPM_BUILD_ROOT}/%{serverdir}
    mv shared/* ${RPM_BUILD_ROOT}/%{shareddir}
    mv webapps/* ${RPM_BUILD_ROOT}/%{appdir}
    mv temp/* ${RPM_BUILD_ROOT}/%{tempdir}
popd

# create reloctomcat4 (is this needed anymore?)
cat >> $RPM_BUILD_ROOT/%{bindir}/reloctomcat4 <<EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC

# rename catalina/jasper into dtomcat4/djasper4 to let wrapper take precedence
install -m 755 $RPM_BUILD_ROOT/%{bindir}/jasper.sh \
    $RPM_BUILD_ROOT/%{_bindir}/d%{full_jname}
install -m 755 $RPM_BUILD_ROOT/%{bindir}/catalina.sh \
    $RPM_BUILD_ROOT/%{_bindir}/d%{name}

# SySV init and logging
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT/%{confdir}/%{name}.conf
# install wrapper as tomcat4/jasper4
install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{_bindir}/%{name}
install -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{full_jname}
# install logrotate support
install -m 755 %{SOURCE7} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
install -m 755 %{SOURCE8} $RPM_BUILD_ROOT/%{bindir}/relink

# remove cruft
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f $RPM_BUILD_ROOT%{bindir}/*.sh \
    $RPM_BUILD_ROOT%{bindir}/*.bat \
    $RPM_BUILD_ROOT/%{bindir}/catalina.sh.* \
    $RPM_BUILD_ROOT/%{bindir}/*.orig

# FHS compliance patches, not easy to track them all boys :)
for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf \
         $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} \
         $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{jname} \
         $RPM_BUILD_ROOT%{_bindir}/%{jname} \
         $RPM_BUILD_ROOT%{bindir}/relink \
         $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}; do
    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done

# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT/%{homedir}
    [ -d bin ] || ln -fs ../../../%{bindir} bin
    [ -d common ] || ln -fs ../../../%{commondir} common
    [ -d conf ] || ln -fs ../../../%{confdir} conf
    [ -d logs ] || ln -fs ../../../%{logdir} logs
    [ -d server ] || ln -fs ../../../%{serverdir} server
    [ -d shared ] || ln -fs ../../../%{shareddir} shared
    [ -d webapps ] || ln -fs ../../../%{appdir} webapps
    [ -d work ] || ln -fs ../../../%{workdir} work
    [ -d temp ] || ln -fs ../../../%{tempdir} temp
popd

# Remove jars and replace with symlinks (the latter done in the post)
pushd $RPM_BUILD_ROOT/%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" | xargs -t rm -f
    # catalina-ant will be installed in _javadir
    mv catalina-ant.jar $RPM_BUILD_ROOT/%{_javadir}/catalina-ant-%{version}.jar
    pushd $RPM_BUILD_ROOT/%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant.jar
        ln -fs catalina-ant-%{version}.jar catalina-ant4.jar
    popd
popd
pushd $RPM_BUILD_ROOT/%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" | xargs -t rm -f
popd
pushd $RPM_BUILD_ROOT/%{commondir}/lib
    find . -name "*.jar" -not -name "naming*" | xargs -t rm -f
popd
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
    find . -name "*.jar" | xargs -t rm -f
popd
# remove duplicate servlet.jar
rm -f $RPM_BUILD_ROOT/%{commondir}/lib/servlet.jar
# remove jar and replace in post with build-jar-repository
rm -f $RPM_BUILD_ROOT/%{bindir}/commons-daemon.jar

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# Add the "tomcat" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{tcuid} -r %{name} 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat4" -u %{tcuid} -g %{name} \
    -s /bin/sh -r -d %{homedir} %{name} 2> /dev/null || :

%preun
# Always clean up wordir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*

if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}

    %{_sbindir}/userdel %{name} >> /dev/null 2>&1 || :
    %{_sbindir}/groupdel %{name} >> /dev/null 2>&1 || :

    # Remove automated symlinks
    for repository in %{serverdir}/lib \
                      %{commondir}/lib \
                      %{commondir}/endorsed \
                      %{bindir}; do
        find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
    done
fi

%preun admin-webapps
if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib \
         -name '\[*\]*.jar' -not -type d | xargs rm -f
fi

%post
# install tomcat4 (but don't activate)
/sbin/chkconfig --add %{name}

### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted

# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat4.conf ] && . %{confdir}/tomcat4.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
for repository in %{serverdir}/lib \
                  %{commondir}/lib \
                  %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d | xargs rm -f
done

build-jar-repository %{serverdir}/lib commons-beanutils commons-fileupload \
                                      commons-digester commons-logging \
                                      commons-modeler regexp jmxri jaas \
                                      catalina-ant4 2>&1

build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-pool commons-logging-api jaf \
                                      jdbc-stdext jta javamail jndi \
                                      servletapi4 jasper4-compiler \
                                      jasper4-runtime 2>&1

build-jar-repository %{commondir}/endorsed jaxp_parser_impl \
                                           xml-commons-apis 2>&1

build-jar-repository %{bindir} commons-daemon 2>&1

%post admin-webapps
### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat4.conf ] && . %{confdir}/tomcat4.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' -not -type d \
    | xargs rm -f

build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts-1.1 2>&1

%post servlet-%{servletspec}-api
update-alternatives --install %{_javadir}/servlet.jar servlet \
    %{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar 40

%postun servlet-%{servletspec}-api
if [ "$1" = "0" ]; then
    update-alternatives --remove servlet \
        %{_javadir}/%{name}-servlet-%{servletspec}-api-%{version}.jar
fi

%post %{jname}-javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun %{jname}-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(644,root,root,755)
%doc %{packname}/{LICENSE,README*,RELE*}
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/cache/%{name}
%dir %{commondir}
%dir %{serverdir}
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib
%{_javadir}/catalina*.jar
# symlinks
%{homedir}/common
%{homedir}/conf
%{homedir}/logs
%{homedir}/server
%{homedir}/shared
%{homedir}/webapps
%{homedir}/work
# Directories with special permissions
%attr(770,root,tomcat4) %dir %{appdir}
%attr(775,root,tomcat4) %dir %{confdir}
%attr(775,root,tomcat4) %dir %{tempdir}
%attr(775,root,tomcat4) %dir %{workdir}
%attr(755,tomcat4,tomcat4) %dir %{logdir}
%attr(755,root,root) %{_bindir}/%{name}
%attr(755,root,root) %{_bindir}/d%{name}
%attr(755,root,root) %{bindir}/*
%attr(755,root,root) %{_sysconfdir}/init.d/%{name}
%attr(644,root,tomcat4) %config(noreplace) %{confdir}/catalina.policy
%attr(660,root,tomcat4) %config(noreplace) %{confdir}/jk2.properties
%attr(660,root,tomcat4) %config(noreplace) %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat4.conf
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml
%{confdir}/server-noexamples.xml.config
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{commondir}/*
%{serverdir}/lib/*
%{tempdir}/README.txt

%files webapps
%defattr(640,root,tomcat4,770)
%dir %{appdir}/examples
%{appdir}/examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*

%files admin-webapps
%defattr(640,root,tomcat4,750)
%{appdir}/admin.xml
%{appdir}/manager.xml
%dir %{serverdir}/webapps
%{serverdir}/webapps/*

%files servlet-%{servletspec}-api
%defattr(644,root,root,755)
%doc %{servpackname}/{LICENSE,README.txt}
%{_javadir}/servletapi*.jar

%files servlet-%{servletspec}-api-javadoc 
%defattr(644,root,root,755)
%doc %{servpackname}/{LICENSE,README.txt}
%{_javadocdir}/%{name}-servlet-2.3-api-%{version}

%files %{jname}
%defattr(644,root,root,755)
%doc %{packname}/{LICENSE,README*,RELE*}
%attr(755,root,root) %{_bindir}/jspc4
%attr(755,root,root) %{_bindir}/%{full_jname}
%attr(755,root,root) %{_bindir}/d%{full_jname}
%{_javadir}/%{jname}*.jar

%files %{jname}-javadoc
%defattr(644,root,root,755)
%doc %{packname}/{LICENSE,README*,RELE*}
%{_javadocdir}/%{name}-%{jname}-%{version}

%changelog
* Wed Mar 02 2005 Jason Corley <jason.corley@gmail.com> 0:4.1.31-1jpp
- Update to 4.1.31
- incorporate jasper and servletapi packages

* Fri Sep 10 2004 Fernando Nasser <fnasser@redhat.com> 0:4.1.30-6jpp
- Rebuild using Tyrex 1.0.1

* Sat Sep 04 2004 Fernando Nasser <fnasser@redhat.com> - 0:4.1.30-5jpp
- Rebuild with Ant 1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:4.1.30-4jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:4.1.30-3jpp
- Upgrade to Ant 1.6.X

* Fri Mar 19 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:4.1.30-2jpp
- Set JAVA_ENDORSED_DIRS by default in tomcat5.conf, it is otherwise empty
  Suggestion from Aleksander Adamowski <aleksander.adamowski@altkom.pl>

* Tue Mar 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:4.1.30-1jpp
- 4.1.30
- Added Patch #2 (jakarta-tomcat-4.1.30-allowTrace.patch),
  courtesy of Henning P. Schmiedehausen <hps@intermeta.de>

* Mon Feb 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:4.1.29-3jpp
- Fixed build of admin webapps
- Use external jasper4

* Sat Jan 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:4.1.29-2jpp
- Create TC4 user and group separately. Lets TC4 work out of the box
  on Trustix (Patch from Iain Arnell)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:4.1.29-1jpp
- 4.1.29
- Require dbcp >= 1.1
- Have regexp use nonversioned name during the build and creation
  of jar repositories
- Rename catalina-ant.jar to catalina-ant4.jar in %%{_javadir}
- RPMs are not supposed to print things while installing, removed
  notice about the service not being active by default

* Thu Oct 09 2003 Paul Nasrat <pauln @ truemesh.com> 0:4.1.27-2jpp
- Fix requires for regexp

* Wed Aug 27 2003 Paul Nasrat <pauln @ truemesh.com> 0:4.1.27-1jpp
- Update to 4.1.27
- remove fileupload patch

* Wed Jul 23 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-12jpp
- config(noreplace) logrotate file
- remove automated links on uninstall
- move catalina.jar to %{_javadir} so ant can use it
- move automated links creation to %post
- fileutils build fix (thanks Ville)
- restrict barf-o-matic to initial installation
- lots of rpm -V fixes

* Mon Jun 23 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-11jpp
- fix owning of a few directories
- common/lib needs commons-logging-api, not commons-logging
[ once again credits go to Leonid Dubinsky for accurate reporting ]

* Thu Jun 12 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-10jpp
- add Borland JBuilder -compat symlinks
- add javamail providers do the package
[ credits to Leonid Dubinsky for reporting this ]

* Thu Jun 12 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-9jpp
- fix logrotate location
- add compat subpackage

* Tue Jun 10 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-8jpp
- fix admin webapp config instead of workarounding.
- remove unused log4j dep

* Fri Jun 10 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-7jpp
- copy jar files instead of linking them in webapps to work around jakarta bug

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-6jpp
- Probably working version

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-5jpp
- stricter fhs compliance
- use jpackge 1.5 jar autodetection routines
- doc still broken
- still needs rebuild-jar-repository calls at stertup to freshen links

* Mon May 12 2003 David Walluck <david@anti-microsoft.org> 0:4.1.24-4jpp
- add epoch to package
- add epoch's to all requires
- fix jta reuirement
- use -Dbuild.compiler=modern instead of use_jikes=false
- really set java.home for ant
- use %%_java macros
- use build-classpath
- remove unpackaged files (see comment)

* Thu May 08 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-3jpp
- rebuild for jpackage 1.5
- avoid error reports when removing user at uninstall time

* Fri Mar 28 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-2jpp
- 4.1.24
- use javamail instead of old monolithic javamail

* Wed Mar 19 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-1jpp
- 4.1.24 alpha

* Tue Mar 18 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.23-1jpp
- 4.1.23 alpha
- complete release include commons-fileupload-1.0-beta1

* Fri Mar 14 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-3jpp
- fix init script

* Wed Mar 12 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-2jpp
- rpm release 2
- init script control now that tomcat isn't allready running at start
- don't remove run/lock if tomcat stop failed in init script stop

* Mon Mar 10 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-1jpp
- 4.1.22 alpha

* Thu Mar 06 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.21-2jpp
- 4.1.21 beta
- rpm release 2
- improved tomcat script which will store main java process in file
  pointed by CATALINA_PID env var if existing, and will kill tomcat if
  it didn't stop after SHUTDOWN_WAIT seconds (tomcat4.conf)

* Wed Feb 26 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.21-1jpp
- 4.1.21 alpha
- use mx4j 1.1.1 for which jar changed from mx4j.jar to mx4j-jmx.jar

* Thu Feb 13 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.20-1jpp
- 4.1.20 alpha
- full version bundled with update beanutils 1.6

* Fri Jan 24 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-2jpp
- rpm release 2
- fix rights on tomcat-users.xml and jk2.properties, only root and tomcat4
  user could update it (reported by Boris Folgmann)

* Wed Jan 15 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-1jpp
- 4.1.19 alpha
- new requirement, commons-fileupload

* Fri Dec 20 2002 Ville SkyttÃÂÂÃÂÂ¤ <ville.skytta at iki.fi> - 4.1.18-1jpp
- 4.1.18 stable, security update release.

* Wed Dec 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.17-1jpp
- 4.1.17 stable release

* Wed Dec 03 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 beta release

* Wed Nov 27 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 alpha release

* Tue Nov 19 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.15-1jpp
- 4.1.15 release

* Tue Oct 29 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-3jpp
- rpm release 3
- relax perms in webapps, tomcat4 could now write in it and as
  suck will be able to autoexpand wars.

* Mon Oct 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-2jpp
- rpm release 2
- fix tomcat4.conf to use /etc/java/java.conf
- fix tomcat4 initd to be sure that we'll stop/start the task owner by
  TOMCAT_USER and running catalina
- fix perms on %{confdir}, contents is owned by root.tomcat4, and only
  jk2.properties and tomcat-users.xml could be updated by tomcat4 user.
- change ref and use of xerces-j2.jar by jaxp_parser_impl.jar.
- include ant 1.5.1
- remove commons-lang as no more required
- copy a correct mod_jk.jpeg

* Mon Sep 30 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-1jpp
- 4.1.12 release
- include commons-logging 1.0.2, xerces-j2 2.1.0
- warning: do not use xerces-j2 2.2.0 which cause strange parse exception
  making Tomcat 4.1.12 to fail at startup

* Mon Sep 16 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-4jpp
- rpm release 4
- fixed java.conf location in misc documents and messages

* Fri Sep 13 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-3jpp
- rpm release 3
- fix TOMCAT4.README.RPM documentation

* Fri Sep 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-2jpp
- rpm release 2
- fix java.conf location
- webapps are owned by root:tomcat4 750/640
- fix initd script to ensure using pidof catalina

* Mon Sep 09 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-1jpp
- 4.1.10 release
- jasper jars moved from shared/lib to common/lib
- full version bundled with latest release of :
  javamail 1.3, jaf 1.0.2, beanutils 1.4.1, commons-pool 1.0.1

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-4jpp
- rpm release 4
- Requires jta-1.0.1a

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-3jpp
- rpm release 3
- the rpm could be now built in 3 modes :
  ligth, follow jakarta LE tarball, ie didn't include stuff present in JDK 1.4
  full,  follow jakarta FULL tarball, ie include everything needed
  strict, include only tomcat stuff, requires all others to be allready present
  (jakarta-commons-*, regexp, serlvet-2.3...)
- commons-logging, regexp and servlet jars should be also included in LE mode
- TOMCAT4.README.RPM updated
- copy struts.jar in admin-webapp since symlinking it make admin webapp failed !

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-2jpp
- rpm release 2
- fix jasper4 and jspc4 scripts
- set Vendor and Distribution tags to JPackage
- add JSSE if found in usual JPackage location (%{_javadir})

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-1jpp
- 4.1.9
- add commons-lang to required package for build
- make use of commons-logging 1.0.1
- remove the ugly hack in start/stop

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-2jpp
- rpm release 2
- fix jdbcext jar name
- use jakarta-commons-logging 1.0.1 release package
- use jpackage-utils in tomcat4.conf and correct /etc/java.conf check

* Wed Jul 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-1jpp
- tomcat 4.1.7
- take care of new jaxp apis/impl policy
- update build since jsse is now under javadir/jsse
- new package, admin-webapps
- tomcat4 need write access to the conf dir, so the dir is owned by tomcat4

* Wed Jun 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-2jpp
- rpm release 2
- change build order : jtc/util, tc4, jtc/coyote, jtc/jk
- the rpm requires that you define your system Java SDK in /etc/java.conf
  or %{confdir}/%{name}.conf (at least define JAVA_HOME)
  Take a look at TOMCAT4.README.RPM for more explanations
- layout changes to meet FHS recommandations :
- use /var/cache/tomcat4 instead of /var/run/tomcat4/{work,temp}
- moved conf from /etc/tomcat4/conf to /etc/tomcat4
- logs/work/temp and webapps now owned by tomcat4 user
- fix regexp name and location

* Mon Jun 24 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-1jpp
- tomcat-v4.0.4
- this rpm is equivalent to jakarta-tomcat-4.0.4 full.
- tomcat4 is more FHS compliant, using symlinks to homedir
- tomcat4 use standard port, relocation command reloctomcat4 is
  provided to make it listen to alternate ports to make it
  compatible with a present tomcat 3.3
- unique rpm for both jpackage.org and jakarta.org
- commons-logging is the one from packager site until an official 1.0.1
  release will be out
- Take a look at TOMCAT4.README.RPM for more informations about RPM

* Tue Apr 30 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.4-b2
- correct postun script, remove linked jars after service stop

* Fri Apr 26 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3 rpm release 2
- misc spec/rpm fixes.

* Mon Mar 04 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3
- security fix
- add symlinking info at post time

* Tue Feb 19 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 3
- correct missing tools.jar in CLASSPATH in both tomcat4 and jasper4

* Fri Feb 15 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 2
- correct bad perms for webapps dir
- warn user at install time if ext jars are not found
- use new tarball for JTC (jakarta-tomcat-connectors-4.0.2-01-src)

* Mon Feb 11 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2
- rpm use the light distribution mode whereas jndi, javamail, jta and jdbc-ext
  are not required.
- rpm now is fully rpm compliant, jakarta-regexp, servletapi4, xerces rpm are
  required for build and should be present, they will be linked at install time.

* Wed Jan 23 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2-b2
- removed tomcat 4.0.2-b2 binary tarball to save place in srpm
- removed manual package, stuff will be only in webapps
- due to Sun Licence we couldn't provide jaf, javamail, jdbc-ext, jmxri, jndi, jta
  jars in source package, so the build dependencies will require to have them
  ALLREADY present in %{_javadir}.
- rpm 4.0.3 have problem with _ in dependencies, jdbcext/jta buildrequire has
  been commented BUT are needed

* Fri Oct 24 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.1
- ajp13 support is now included by default in Tomcat 4.0, so I've included
  stuff from jakarta-tomcat-connectors CVS (20011023) to rebuild ajp connector
  from source
- since you could have also a tomcat 3.x running, listen port in Tomcat 4.0
  rpm have been translated :
  HTTP 1.1 from 8080 to 8180, Proxied HTTP 1.1 from 8081 to 8181,
  HTTP 1.1/SSL from 8443 to 8543 and AJP13 from 8009 to 8109
  HTTP 1.0 from port 8082 to 8182
  if you want to use original values, edit file %{homedir}/conf/server.xml
- connectors activated by default are HTTP 1.1, WARP and AJP13
- rework RPM to have tomcat4 works under user tomcat4 (like tomcat 3.3 RPM)
- fix images corruptions

* Mon Oct 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0
- to avoid license problem both source and binary are included in the source rpm
  we use binary tarball to get required jar, jndi, mail, jta...
- Java Managment Extension, jmx is included in source rpm for build purpose but
  won't be installed in binary rpm again for license problem.
- many RPM enhancements from suggestion from Keith Irwin <keith_irwin@non.hp.com>,
  Nicolas Mailhot <nicolas.mailhot@one2team.com> and Jun Inamori. A big thanks
  to all of them
- tomcat run as nobody (finally) in init.d.
  BE CAREFULL NOW WHEN running tomcat as root (in interactive mode for example)
  since you could then make some files unreadable
- a config file is available for init.d script tuning, tomcat.conf, in %{confdir}
- no external parser is required since crimson (jaxp 1.1) is now included
- this RPM is still not FHS, need some reworks...
- no external parser is required since crimson (jaxp 1.1) is now included
- built under Redhat 6.2 with updates, jikes 1.15, ant 1.4, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Thu Sep 13 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0-rc1
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Tue Jun 05 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b5
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010502), jsse 1.0.2
- included xerces 1.4.0

* Fri May 11 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b4

* Wed Apr 18 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b3

* Mon Apr 02 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b2
- second beta release of tomcat 4
- big cleanup of the SPEC which was just to complex.
- Need now a jaxp 1.1 conforming parser, => require xerces-j 1.3.1
- removed jaxp 1.0 / 1.1 from SPEC since we're using xerces-j 1.3.1
  (jaxp 1.1 / crimson is include in tomcat sources)
- YOU MUST HAVE the JSSE 1.0.2 jars in /usr/share/java (I've built a
  jsse RPM from Sun Jars but I COULD'T MAKE IT AVAILABLE...)

* Mon Jan 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b1
- first beta release of tomcat 4

* Thu Dec 14 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m5

* Thu Nov 02 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m4

* Tue Oct 24 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3 RPM Release 2
- corrected jars included
- we assume you've installed jsse jars in /usr/share/java
- renamed tomcat4-doc to tomcat4-manual (follow apache RPM naming)
- RH 7.0 changes location of docdir and DocumentRoot. The spec file is modified
  to place manual in right place when rebuilded under RH 6.x or RH 7.0
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5
- build CLASSPATH=

* Thu Oct 19 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3

* Tue Oct 17 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m2 RPM Release 2
- follow Debian policy about java stuff, libs in /usr/share/java,
  executable in /usr/bin, apps datas in %{homedir}
- prepare transition to RH 7.0 new document root (/var/www)
- build CLASSPATH=/usr/share/java/jsse.jar:/usr/share/java/jcert.jar:/usr/share/java/jnet.jar

* Thu Oct 12 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m2
- to allow tomcat 3.x and tomcat 4.x coexistence, the RPM is named tomcat4.
  It start at version 4.0 and all datas will goes in /home/tomcat4.
- tomcat 4.0 need ant post 1.1, xerces 1.2.0, jsse 1.0.1 (min) and jmx.
  The RPM include ant post 1.1 (for build) and jmx (jmxri.jar for build/run) .
  I couldn't include JSSE stuff so you must download JSSE from java.sun.com.
  Next install jcert.jar, jnet.jar and jsse.jar in BOTH
  /usr/lib/java AND JAVA_HOME/jre/lib/ext
- TC 4.0 HTTP 1.1 connector moved from port 8080 to 8180 and
  from port 8081 to 8181 for HTTP 1.0 connector
  (TC 3.x allready listen on 8080/8081)

* Sat Oct 07 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m1
- RPM never released

* Fri Oct 06 2000 Henri Gomez <hgomez@users.sourceforge.net>
- RPM release 2
- tomcat is now installed on /home/tomcat instead of
  /opt/tomcat since /opt is mounted read-only on
  many systems <summer@os2.ami.com.au>
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar
- correct stuff in spec file (copyright, group...)

* Mon Sep 25 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v3.2-beta-5 RPM
- detect jikes and use it to rebuild (yep 10 times faster).
- patched incorrect version number
- rebuilded with jikes 1.12 (and jsse 1.0.2).
